package com.ichaoj.ams.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ichaoj.ams.entity.AmsExecuteRecord;
import com.ichaoj.ams.entity.AmsTradeRecord;
import com.ichaoj.ams.mapper.AmsTradeRecordMapper;
import com.ichaoj.ams.request.record.PageTradeRecordRequest;
import com.ichaoj.ams.response.execute.ExecuteResponse;
import com.ichaoj.ams.response.record.TradeRecordResponse;
import com.ichaoj.ams.service.IAmsTradeRecordService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ichaoj.common.model.PublicPage;
import com.ichaoj.mybatis.service.SuperWhaleServiceImpl;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 交易 服务实现类
 * </p>
 *
 * @author cjwen
 * @since 2023-05-18
 */
@Service
public class AmsTradeRecordServiceImpl extends SuperWhaleServiceImpl<AmsTradeRecordMapper, AmsTradeRecord> implements IAmsTradeRecordService {

    @Override
    public PublicPage<TradeRecordResponse> pageTradeRecord(PageTradeRecordRequest pageRequest) {
        LambdaQueryWrapper<AmsTradeRecord> wrapper = Wrappers.lambdaQuery();
        wrapper
                .eq(StrUtil.isNotBlank(pageRequest.getQueryValue()), AmsTradeRecord::getExecuteId, pageRequest.getQueryValue())
                .or().eq(StrUtil.isNotBlank(pageRequest.getQueryValue()), AmsTradeRecord::getTxId, pageRequest.getQueryValue())
                .orderByDesc(AmsTradeRecord::getCreateTime);
        Page<AmsTradeRecord> result = this.page(this.buildPageObj(pageRequest), wrapper);
        return this.convertPublicPage(result, s -> BeanUtil.copyProperties(s, TradeRecordResponse.class));
    }

}
